import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "!WQVQPOOOhQPO'#CdOOQO'#Ci'#CiOOQO'#Ce'#CeQVQPOOOOQO,59O,59OOoQPO,59OOOQO-E6c-E6cOOQO1G.j1G.j",
  stateData: "y~O[OS~OQQORQOSQOTQOVPO~OUTO~PVOUWO~PVOTQ~",
  goto: "u^PPPPPPPP_ePPPoXQOPSUQSOQUPTVSUXROPSU",
  nodeNames: "⚠ NuFormula Operator Keyword String Number ) ( Application",
  maxTerm: 13,
  nodeProps: [
    ["openedBy", 6,"("],
    ["closedBy", 7,")"]
  ],
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "'_~RaXY!WYZ!W]^!Wpq!Wrs!]xy$uyz$zz{%P{|%U}!O%U!O!P%a!P!Q%P!Q![&a!^!_&r!_!`%P!`!a&}!c!}'V~!]O[~~!`Wpq!]qr!]rs!xs#O!]#O#P!}#P;'S!];'S;=`$o<%lO!]~!}OS~~#QXrs!]!P!Q!]#O#P!]#U#V!]#Y#Z!]#b#c!]#f#g!]#h#i!]#i#j#m~#pR!Q![#y!c!i#y#T#Z#y~#|R!Q![$V!c!i$V#T#Z$V~$YR!Q![$c!c!i$c#T#Z$c~$fR!Q![!]!c!i!]#T#Z!]~$rP;=`<%l!]~$zOV~~%POU~~%UOQ~~%ZQQ~!O!P%a!Q![&a~%dP!Q![%g~%lRT~!Q![%g!g!h%u#X#Y%u~%xR{|&R}!O&R!Q![&X~&UP!Q![&X~&^PT~!Q![&X~&fST~!O!P%g!Q![&a!g!h%u#X#Y%u~&wQQ~!_!`%P!`!a%P~'SPQ~!_!`%P~'[PR~!c!}'V",
  tokenizers: [0],
  topRules: {"NuFormula":[0,1]},
  tokenPrec: 38
});

const NuformulaLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Keyword: tags.keyword,
                String: tags.string,
                Number: tags.number,
                Operator: tags.operator,
                PropertyName: tags.propertyName,
                "( )": tags.paren,
                ",": tags.separator
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: ";" },
    },
});
function nuformula() {
    return new LanguageSupport(NuformulaLanguage);
}

export { NuformulaLanguage, nuformula };
